侧边栏壁纸
  • 累计撰写 93 篇文章
  • 累计创建 170 个标签
  • 累计收到 88 条评论
标签搜索

目 录CONTENT

文章目录

Shell脚本中特殊符号的用法-运维总结

seven
2023-10-30 / 0 评论 / 0 点赞 / 331 阅读 / 5,401 字
温馨提示:
本文最后更新于 2023-10-30,若内容或图片失效,请留言反馈。部分素材来自网络,若不小心影响到您的利益,请联系我们删除。

#井号(comments)html

这几乎是个shell满场都有的符号,用在shell脚本的开头,如“#!/bin/bash”
井号也常出如今一行的开头,或者位于完整指令以后,这类状况表示符号后面的是注释文字,不会被执行。
因为这个特性,当临时不想执行某行指令时,只需在该行开头加上#就好了。这经常使用在撰写过程当中。
若是被用在指令中,或者引号双引号括住的话,或者在倒斜线的后面,那他就变成通常符号,不具上述的特殊功能。

~账户的home目录

算是个常见的符号,表明使用者的home目录:cd ~;也能够直接在符号后加上某账户的名称:cd ~user或者当成是路径的一部份:~/bin

~+当前的工做目录,这个符号表明当前的工做目录,她和内置指令pwd的做用是相同的。

# echo ~+/var/log

~-上次的工做目录,这个符号表明上次的工做目录。

# echo ~-/etc/httpd/logs

;分号(Command separator)

在shell中,担任\“连续指令\”功能的符号就是\“分号\”。譬如如下的例子:

cd ~/backup;mkdir startup;cp ~/.* startup/.

;;连续分号(Terminator)

专用在case的选项,担任Terminator的角色。

case \“$fop\”inhelp)echo \“Usage: Command -help -version filename\”;;version)echo \“version 0.1\”;;esac

.顿号(dot,就是「点」)

在shell中,使用者应该都清楚,一个dot表明当前目录,两个dot表明上层目录。

CDPATH=.:~:/home:/home/web:/var:/usr/local

在上行CDPATH的设定中,等号后的dot表明的就是当前目录的意思。

若是档案名称以dot开头,该档案就属特殊档案,用ls指令必须加上-a选项才会显示。除此以外,在regularexpression中,一个dot表明匹配一个字元。

'string’单引号(single quote)

被单引号用括住的内容,将被视为单一字串。在引号内的表明变数的$符号,没有做用,也就是说,他被视为通常符号处理,防止任何变量替换。

heyyou=homeecho '$heyyou' # We get $heyyou

\“string\”双引号(double quote)

被双引号用括住的内容,将被视为单一字串。它防止通配符扩展,但容许变量扩展。这点与单参数的处理方式不一样。

heyyou=homeecho \“$heyyou\”# We get home

command倒引号(backticks)

在前面的单双引号,括住的是字串,但若是该字串是一列命令列,会怎样?答案是不会执行。要处理这种状况,咱们得用倒单引号来作。

fdv=`date +%F`echo \“Today $fdv\”

在倒引号内的date +%F会被视为指令,执行的结果会带入fdv变数中。

,逗号(comma,标点中的逗号)

这个符号常运用在运算当中当作\“区隔\”用途。以下例

#!/bin/bash

let \“t1 =((a = 5 + 3,b = 7 - 1,c = 15 / 3))\”

echo \“t1= $t1,a = $a,b = $b\”

/斜线(forward slash)

在路径表示时,表明目录。

cd /etc/rc.dcd …/…cd /

一般单一的/表明root根目录的意思;在四则运算中,表明除法的符号。

let \“num1 =((a = 10 / 2,b = 25 / 5))\”

\\倒斜线

在交互模式下的escape字元,有几个做用;放在指令前,有取消aliases的做用;放在特殊符号前,则该特殊符号的做用消失;放在指令的最末端,表示指令连接下一行。

# type rmrm is aliased to `rm -i'# \\rm ./*.log

上例,我在rm指令前加上escape字元,做用是暂时取消别名的功能,将rm指令还原。

# bkdir=/home# echo \“Backup dir,\\$bkdir = $bkdir\”Backup dir,$bkdir = /home

上例echo内的\\$bkdir,escape将$变数的功能取消了,所以,会输出$bkdir,而第二个$bkdir则会输出变数的内容/home。

|管道(pipeline)

pipeline是UNIX系统,基础且重要的观念。连接上个指令的标准输出,作为下个指令的标准输入。

who | wc -l

善用这个观念,对精简script有至关的帮助

!惊叹号(negate or reverse)

一般它表明反逻辑的做用,譬如条件侦测中,用!=来表明\“不等于\”

if [ \“$?\”!= 0 ]thenecho \“Executes error\”exit 1fi

在规则表达式中她担任\“反逻辑\”的角色

ls a[!0-9]

上例,表明显示除了a0,a1….a9这几个文件的其余文件。

:冒号

在bash中,这是一个内置指令:\“什么事都不干\”,但返回状态值0。

:

echo $?#回应为0

:> f.$$

上面这一行,至关于cat /dev/null >f.$$。不只写法简短了,并且执行效率也好上许多。

有时,也会出现如下这类的用法

:${HOSTNAME?} ${USER?} ${MAIL?}

这行的做用是,检查这些环境变数是否已设置,没有设置的将会以标准错误显示错误讯息。像这种检查若是使用相似test或if这类的作法,基本上也能够处理,但都比不上上例的简洁与效率。

?问号(wild card)

在文件名扩展(Filename expansion)上扮演的角色是匹配一个任意的字元,但不包含null字元。

# ls a?a1

善用她的特色,能够作比较精确的文件名匹配。

*星号(wild card)

至关经常使用的符号。在文件名扩展(Filename expansion)上,她用来表明任何字元,包含null字元。

# ls a*a a1 access_log

在运算时,它则表明\“乘法\”。

let \“fmult=2*3\”

除了内置指令let,还有一个关于运算的指令expr,星号在这里也担任\“乘法\”的角色。不过在使用上得当心,他的前面必须加上escape字元。

**次方运算

两个星号在运算时表明\“次方\”的意思。

let \“sus=2**3\”echo \“sus = $sus\”# sus = 8

$钱号(dollar sign)

变量替换(Variable Substitution)的表明符号。

vrs=123echo \“vrs = $vrs\”# vrs = 123

另外,在Regular Expressions里被定义为\“行\”的最末端(end-of-line)。这个经常使用在grep、sed、awk以及vim(vi)当中。

${}变量的正规表达式

bash对${}定义了很多用法。如下是取自在线说明的表列

${parameter:-word} ${parameter:=word} ${parameter:?word} ${parameter:+word} ${parameterffset} ${parameterffset:length} ${!prefix*} ${#parameter} ${parameter#word} ${parameter##word} ${parameter%word} ${parameter%%word} ${parameter/pattern/string} ${ parameter//pattern/string}

$*

$*引用script的执行引用变量,引用参数的算法与通常指令相同,指令自己为0,其后为1,而后依此类推。引用变量的表明方式以下:

$0,$1,$2,$3,$4,$5,$6,$7,$8,$9,${10},${11}…..

个位数的,可直接使用数字,但两位数以上,则必须使用{}符号来括住。

$*则是表明全部引用变量的符号。使用时,得视状况加上双引号。

echo \“$*\”

还有一个与$*具备相同做用的符号,但效用与处理方式略为不一样的符号。

$@

$@与$*具备相同做用的符号,不过她们二者有一个不一样点。

符号$*将全部的引用变量视为一个总体。但符号$@则仍旧保留每一个引用变量的区段观念。

$#

这也是与引用变量相关的符号,她的做用是告诉你,引用变量的总数量是多少。

echo \“$#\”

$?状态值(status variable)

通常来讲,UNIX(linux)系统的进程以执行系统调用exit()来结束的。这个回传值就是status值。回传给父进程,用来检查子进程的执行状态。

通常指令程序假若执行成功,其回传值为0;失败为1。

tar cvfz dfbackup.tar.gz /home/user > /dev/nullecho\“$?\”$$

因为进程的ID是惟一的,因此在同一个时间,不可能有重复性的PID。有时,script会须要产生临时文件,用来存放必要的数据。而此script亦有可能在同一时间被使用者们使用。在这种状况下,固定文件名在写法上就显的不可靠。惟有产生动态文件名,才能符合须要。符号$$或许能够符合这种需求。它表明当前shell的PID。

echo \“$HOSTNAME,$USER,$MAIL\”> ftmp.$$

使用它来做为文件名的一部份,能够避免在同一时间,产生相同文件名的覆盖现象。

ps:基本上,系统会回收执行完毕的PID,而后再次依须要分配使用。因此script即便临时文件是使用动态文件名的写法,若是script执行完毕后仍不加以清除,会产生其余问题。

()指令群组(command group)

用括号将一串连续指令括起来,这种用法对shell来讲,称为指令群组。以下面的例子:(cd ~;vcgh=pwd;echo $vcgh),指令群组有一个特性,shell会以产生subshell来执行这组指令。所以,在其中所定义的变数,仅做用于指令群组自己。咱们来看个例子

# cat ftmp-01#!/bin/basha=fsh(a=incg;echo -e \“\\n $a \\n\”)echo $a#./ftmp-01incgfsh

除了上述的指令群组,括号也用在array变数的定义上;另外也应用在其余可能须要加上escape字元才能使用的场合,如表达式。

(())

这组符号的做用与let指令类似,用在算数运算上,是bash的内置功能。因此,在执行效率上会比使用let指令要好许多。

#!/bin/bash((a = 10))echo -e \“inital value,a = $a\\n\”((a++))echo \“after a++,a = $a\”

{ }大括号(Block of code)

有时候script当中会出现,大括号中会夹着一段或几段以\“分号\”作结尾的指令或变数设定。

# cat ftmp-02#!/bin/basha=fsh{a=inbc;echo -e \“\\n $a \\n\”}echo $a#./ftmp-02inbcinbc

这种用法与上面介绍的指令群组很是类似,但有个不一样点,它在当前的shell执行,不会产生subshell。

大括号也被运用在\“函数\”的功能上。广义地说,单纯只使用大括号时,做用就像是个没有指定名称的函数通常。所以,这样写script也是至关好的一件事。尤为对输出输入的重导向上,这个作法可精简script的复杂度。

此外,大括号还有另外一种用法,以下

{xx,yy,zz,…}

这种大括号的组合,经常使用在字串的组合上,来看个例子

mkdir{userA,userB,userC}-{home,bin,data}

咱们获得userA-home,userA-bin,userA-data,userB-home,userB-bin,userB-data,userC-home,userC-bin,userC-data,这几个目录。这组符号在适用性上至关普遍。能加以善用的话,回报是精简与效率。像下面的例子

chown root /usr/{ucb/{ex,edit},lib/{ex?.?*,how_ex}}

若是不是由于支持这种用法,咱们得写几行重复几回呀!

[ ]中括号

常出如今流程控制中,扮演括住判断式的做用。

if [ \“$?\”!= 0 ]thenecho \“Executes error\”exit1fi

这个符号在正则表达式中担任相似\“范围\”或\“集合\”的角色

rm -r 200[1234]

上例,表明删除2001,2002,2003,2004等目录的意思。

通配符扩展:
容许匹配方括号中任何一个单个字符
代码:

ls /[eh][to][cm]*

至关于执行ls /etc /home(如有/eom目录,就至关于会执行ls /etc /home /eom)
注:在mkdir命令下不能扩展

[[ ]]

这组符号与先前的[]符号,基本上做用相同,但她容许在其中直接使用||与&&逻辑等符号。

#!/bin/bashread akif [[ $ak > 5 || $ak< 9 ]]thenecho $akfi

||逻辑符号

这个会时常看到,表明or逻辑的符号,表示前一个命令执行成功,则就此结束,后一个命令就不执行;前一个命令执行失败,后一个命令才会执行。如A || B表示A执行成功后,B就不会再执行了;A执行失败或不执行,B才能执行。

&&逻辑符号

这个也会常看到,表明and逻辑的符号,表示串行,即前一个命令执行成功,后一个命令才接着执行;前一个命令执行失败,则就此结束,后一个命令也不会执行。如A && B表示A执行成功后,B也会跟着执行了;A执行失败或不执行,B也不会执行了。

&后台工做

单一个&符号,且放在完整指令列的最后端,即表示将该指令列放入后台中工做。放在几个指令中间时,表示并行,实质就是在后台并行执行,跟指令先后顺序无关。

tar cvfz data.tar.gz data > /dev/null&

\\<…\\>单字边界

这组符号在规则表达式中,被定义为\“边界\”的意思。比如,当咱们想找寻the这个单字时,若是咱们用

grep the FileA

你将会发现,像there这类的单字,也会被当成是匹配的单字。由于the正巧是there的一部份。若是咱们要必免这种状况,就得加上\“边界\”的符号

grep '\the\' FileA

+加号(plus)

在表达式中,她用来表示\“加法\”。

expr 1 + 2 + 3

此外在规则表达式中,用来表示\“不少个\”的前面字元的意思。

# grep '10\\+9' fileB109100910000910000931010009#这个符号在使用时,前面必须加上escape字元。

-减号(dash)

在表达式中,她用来表示\“减法\”。

expr 10 - 2

此外也是系统指令的选项符号。

ls -expr 10 - 2

在GNU指令中,若是单独使用-符号,不加任何该加的文件名称时,表明\“标准输入\”的意思。这是GNU指令的共通选项。譬以下例

tar xpvf -

这里的-符号,既表明从标准输入读取数据。

不过,在cd指令中则比较特别

cd -

这表明变动工做目录到\“上一次\”工做目录。

%模运算

在表达式中,用来表示算术运算中的模运算

例如:echo $((100%10)) 就是100除以10的余数为0。

在文本处理当中常常用来截取字符。

${parameter%word}${parameter%%word}

一个%表示最短的word匹配,两个表示最长的word匹配。

/tmp>i="abc,def,ghi,jlk"
/tmp>echo ${i%%,*}
abc
/tmp>echo ${i%,*}
abc,def,ghi

=等号(Equals)

常在设定变数时看到的符号。

vara=123echo \“vara = $vara\”

或者像是PATH的设定,甚至应用在运算或判断式等此类用途上。

==等号(Equals)

常在条件判断式中看到,表明\“等于\”的意思。

if [ $vara == $varb ]

…下略

!=不等于

常在条件判断式中看到,表明\“不等于\”的意思。

if [ $vara!= $varb ]

…下略

^

这个符号在规则表达式中,表明行的\“开头\”位置,在[]中也与\“!\”(叹号)同样表示「非」

输出/输入重定向

> >> < <<:> &> 2&> 2<>>& >&2

文件描述符(File Descriptor),用一个数字(一般为0-9)来表示一个文件。

经常使用的文件描述符以下:

文件描述符名称经常使用缩写默认值

0标准输入stdin键盘

1标准输出stdout屏幕

2标准错误输出stderr屏幕

咱们在简单地用<或>时,至关于使用0<或1>(下面会详细介绍)。

* cmd > file

把cmd命令的输出重定向到文件file中。若是file已经存在,则清空原有文件,使用bash的noclobber选项能够防止覆盖原有文件。

* cmd >> file

把cmd命令的输出重定向到文件file中,若是file已经存在,则把信息加在原有文件后面。

* cmd < file

使cmd命令从file读入

* cmd << text

从命令行读取输入,直到一个与text相同的行结束。除非使用引号把输入括起来,此模式将对输入内容进行shell变量替换。若是使用<<-,则会忽略接下来输入行首的tab,结束行也能够是一堆tab再加上一个与text相同的内容,能够参考后面的例子。

* cmd <<< word

把word(而不是文件word)和后面的换行做为输入提供给cmd。

* cmd <> file

以读写模式把文件file重定向到输入,文件file不会被破坏。仅当应用程序利用了这一特性时,它才是有意义的。

* cmd >| file

功能同>,但即使在设置了noclobber时也会覆盖file文件,注意用的是|而非一些书中说的!,目前仅在csh中仍沿用>!实现这一功能。

:> filename把文件\“filename\”截断为0长度.#若是文件不存在,那么就建立一个0长度的文件(与’touch’的效果相同).

cmd >&n把输出送到文件描述符n

cmd m>&n把输出到文件符m的信息重定向到文件描述符n

cmd >&-关闭标准输出

cmd <&n输入来自文件描述符n

cmd m<&n m来自文件描述各个n

cmd <&-关闭标准输入

cmd <&n-移动输入文件描述符n而非复制它。(须要解释)

cmd >&n-移动输出文件描述符n而非复制它。(须要解释)

注意:>&实际上复制了文件描述符,这使得cmd > file 2>&1与cmd 2>&1 >file的效果不同。

其它特殊字符

$#是传递给脚本的参数个数;
$0是脚本自己的名字(程序运行本身);
$1是传递给该shell脚本的第一个参数;

$2是传递给该shell脚本的第二个参数;

$@是传递给脚本的全部参数的列表(是多个字符串,每一个参数为1个字符串);
$*是传递给脚本的全部参数的列表(以一个单字符串显示全部参数),与位置变量不一样,参数可超过9个;
$$是运行脚本的当前进程ID号;
$?是显示执行上一条Shell命令的返回值,0表示没有错误,其余表示有错误。
以下,用一个简单的脚原本说明上面这些变量的含义

[root@kevin ~]# vim /root/path.sh
#!/bin/sh
echo "the number of parameters passed to the script: $#"
echo "the name of the script itself: $0"
echo "the first parameter passed to the shell script: $1"
echo "the second parameter passed to the shell script: $2"
echo "the list of all the parameters passed to the script(some string): $@"
echo "the list of all the parameters passed to the script(one string): $*"
echo "the current process ID number of the script which is running: $$"
echo "the return value of the last shell command performed: $?"

[root@kevin ~]# chmod 755 /root/path.sh
[root@kevin ~]# ll /root/path.sh
-rwxr-xr-x. 1 root root 512 Jun 25 11:21 /root/path.sh

[root@kevin ~]# sh /root/path.sh 10 20 30
the number of parameters passed to the script: 3
the name of the script itself: /root/path.sh
the first parameter passed to the shell script: 10
the second parameter passed to the shell script: 20
the list of all the parameters passed to the script(some string): 10 20 30
the list of all the parameters passed to the script(one string): 10 20 30
the current process ID number of the script which is running: 372
the return value of the last shell command performed: 0
0

评论区